## ros-lunar-catkin-pip 0.2.3

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
#
# Here we generate a set of python projects with different structures
# and use them as tests for catkin_pip, in same workspace.
# This CMakeLists is just a way to gather all subprojects
# We assume here that the global workspace setup is already done by the parent CMakeLists.txt
#

find_package(catkin REQUIRED)

# Setting up catkin-pip from source via symlink
add_subdirectory(catkin_pip)

# include the extras (as a catkin components / find_package() would normally do)
# Just because we need to install pip requirements here
include(${CATKIN_DEVEL_PREFIX}/share/catkin_pip/cmake/catkin-pip.cmake)
# note : including only the catkin-pip-requirements cmake here will break because some required variables are not set

# We need to install the common pip dependencies in the workspace being created
# For now we ignore existing platform setup. (might not be best choice ?)
catkin_pip_requirements(${CMAKE_CURRENT_SOURCE_DIR}/test_requirements.txt --ignore-installed)

message(STATUS "PATH $ENV{PATH}")
message(STATUS "PYTHONPATH $ENV{PYTHONPATH}")
message(STATUS "ROS_PACKAGE_PATH $ENV{ROS_PACKAGE_PATH}")

# Make sure we get the right cookiecutter
find_program( CATKIN_COOKIECUTTER NAMES cookiecutter PATHS ${CATKIN_DEVEL_PREFIX}/${CATKIN_GLOBAL_BIN_DESTINATION} NO_DEFAULT_PATH)
if( NOT CATKIN_COOKIECUTTER )
    message( FATAL_ERROR "cookiecutter pip command not found. Make sure you have installed the cookiecutter pip package on your workspace.")
else()
    message(STATUS "cookiecutter found at ${CATKIN_COOKIECUTTER}")
endif()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/pipproject/mypippkg")
    catkin_pip_runcmd(${CATKIN_COOKIECUTTER} --no-input https://github.com/wdm0006/cookiecutter-pipproject.git -o pipproject)
endif()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/pylibrary/python-nameless")
    catkin_pip_runcmd(${CATKIN_COOKIECUTTER} --no-input https://github.com/ionelmc/cookiecutter-pylibrary -o pylibrary)
endif()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/pypackage/python_boilerplate")
    catkin_pip_runcmd( ${CATKIN_COOKIECUTTER} --no-input https://github.com/audreyr/cookiecutter-pypackage -o pypackage)
endif()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/pypackage-minimal/cookiecutter_pypackage_minimal")
    catkin_pip_runcmd( ${CATKIN_COOKIECUTTER} --no-input https://github.com/kragniz/cookiecutter-pypackage-minimal -o pypackage-minimal)
endif()


#
# and make sure they still work with catkin by building them all as subprojects
#

# Testing project itself
catkin_pip_runcmd(rosdep install --from-paths "distutils-setup" --ignore-src -y)
add_subdirectory(distutils-setup)

# Testing project itself
catkin_pip_runcmd(rosdep install --from-paths "setuptools-setup" --ignore-src -y)
add_subdirectory(setuptools-setup)

# Testing project itself
# We need to call rosdep for each packages (to install dependencies if there are any)
# note $ROS_DISTRO must be already defined in the environment
catkin_pip_runcmd(rosdep install --from-paths "pipproject" --ignore-src -y)
add_subdirectory(pipproject)

# Testing project itself
catkin_pip_runcmd(rosdep install --from-paths "pylibrary" --ignore-src -y)
add_subdirectory(pylibrary)

# Testing project itself
catkin_pip_runcmd(rosdep install --from-paths "pypackage" --ignore-src -y)
add_subdirectory(pypackage)

# Testing project itself
catkin_pip_runcmd(rosdep install --from-paths "pypackage-minimal" --ignore-src -y)
add_subdirectory(pypackage-minimal)


if (CATKIN_ENABLE_TESTING)

    #########
    # Pytests
    #########

    # Testing one by one to make sure pyros_setup import
    # doesnt influence tests that should not be influenced...
    catkin_add_pytests(catkin_pip_pytest/test_easyinstallpth.py
        --build-dir ${CMAKE_BINARY_DIR}
        DEPENDENCIES
        ${distutils_setup_PIP_TARGET}                      # from distutils-setup
        ${setuptools_setup_PIP_TARGET}                      # from setuptools-setup
        ${mypippkg_PIP_TARGET}                      # from pipproject
        ${nameless_PIP_TARGET}                      # from pylibrary
        ${python_boilerplate_PIP_TARGET}            # from pypackage
        ${cookiecutter_pypackage_minimal_PIP_TARGET}      # from pypackage-minimal
    )
    catkin_add_pytests(catkin_pip_pytest/test_path.py
        --build-dir ${CMAKE_BINARY_DIR}
        DEPENDENCIES
        ${distutils_setup_PIP_TARGET}                      # from distutils-setup
        ${setuptools_setup_PIP_TARGET}                      # from setuptools-setup
        ${mypippkg_PIP_TARGET}                      # from pipproject
        ${nameless_PIP_TARGET}                      # from pylibrary
        ${python_boilerplate_PIP_TARGET}            # from pypackage
        ${cookiecutter_pypackage_minimal_PIP_TARGET}      # from pypackage-minimal
    )
    catkin_add_pytests(catkin_pip_pytest/test_site.py
        --build-dir ${CMAKE_BINARY_DIR}
        DEPENDENCIES
        ${distutils_setup_PIP_TARGET}                      # from distutils-setup
        ${setuptools_setup_PIP_TARGET}                      # from setuptools-setup
        ${mypippkg_PIP_TARGET}                      # from pipproject
        ${nameless_PIP_TARGET}                      # from pylibrary
        ${python_boilerplate_PIP_TARGET}            # from pypackage
        ${cookiecutter_pypackage_minimal_PIP_TARGET}      # from pypackage-minimal
    )
    catkin_add_pytests(catkin_pip_pytest/test_import.py
        --build-dir ${CMAKE_BINARY_DIR}
        DEPENDENCIES
        ${distutils_setup_PIP_TARGET}                      # from distutils-setup
        ${setuptools_setup_PIP_TARGET}                      # from setuptools-setup
        ${mypippkg_PIP_TARGET}                      # from pipproject
        ${nameless_PIP_TARGET}                      # from pylibrary
        ${python_boilerplate_PIP_TARGET}            # from pypackage
        ${cookiecutter_pypackage_minimal_PIP_TARGET}      # from pypackage-minimal
    )
    catkin_add_pytests(catkin_pip_pytest/test_syspath.py
        --build-dir ${CMAKE_BINARY_DIR}
        DEPENDENCIES
        ${distutils_setup_PIP_TARGET}                      # from distutils-setup
        ${setuptools_setup_PIP_TARGET}                      # from setuptools-setup
        ${mypippkg_PIP_TARGET}                      # from pipproject
        ${nameless_PIP_TARGET}                      # from pylibrary
        ${python_boilerplate_PIP_TARGET}            # from pypackage
        ${cookiecutter_pypackage_minimal_PIP_TARGET}      # from pypackage-minimal
    )

    # Because we need to validate that pyros fixes editable pkg path ordering for us
    catkin_add_pytests(catkin_pip_pytest/test_syspath_pyros.py
        --capture=no --build-dir ${CMAKE_BINARY_DIR}
        DEPENDENCIES
        ${distutils_setup_PIP_TARGET}                      # from distutils-setup
        ${setuptools_setup_PIP_TARGET}                      # from setuptools-setup
        ${mypippkg_PIP_TARGET}                      # from pipproject
        ${nameless_PIP_TARGET}                      # from pylibrary
        ${python_boilerplate_PIP_TARGET}            # from pypackage
        ${cookiecutter_pypackage_minimal_PIP_TARGET}      # from pypackage-minimal
    )

    #TODO : a way to verified installed files from cmake ???

endif()

=== test/distutils-setup/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(distutils_setup)

# This is a full project CMakeLists (in case we call it independently for tests or so)
set (PIP_PROJECT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/distutils_setup)

find_package(catkin REQUIRED COMPONENTS catkin_pip)

# This replace catkin_python_setup()
# For devel, this will install all your unsatisfied pip dependencies.
# Upon install, this will bark if some dependencies are not already satisfied (by ROS).
catkin_pip_target(dstest ${PIP_PROJECT_DIR})

catkin_package()

# CAREFUL : all projects for test here will share the same workspace. pip might have conflicts...

# Testing potential extra files installation
install(FILES extra_installs/bin.txt DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})
install(FILES extra_installs/etc.txt DESTINATION ${CATKIN_PACKAGE_ETC_DESTINATION})
install(FILES extra_installs/include.txt DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})
install(FILES extra_installs/lib.txt DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})
install(FILES extra_installs/python.txt DESTINATION ${CATKIN_PACKAGE_PYTHON_DESTINATION})
install(FILES extra_installs/share.txt DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

## Unit tests
if (CATKIN_ENABLE_TESTING)
    catkin_add_nosetests(${PIP_PROJECT_DIR}/test DEPENDENCIES dstest)
    catkin_add_pytests(${PIP_PROJECT_DIR}/test DEPENDENCIES dstest)
    # Running embedded test from devel space
    catkin_add_nosetests(${PIP_PROJECT_DIR}/dstest/test DEPENDENCIES dstest)
endif()

=== test/pipproject/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(mypippkg)

# This is a full project CMakeLists (in case we call it independently for tests or so)
set (PIP_PROJECT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/mypippkg)

find_package(catkin REQUIRED COMPONENTS catkin_pip)

# For development, we need to install the pip dependencies in the workspace being created
# Upon install, this will not do anything. All requirements should be satisfied by ROS dependencies system.
# => pip dependencies will work from source only
# => to release a pip dependency in a ROS system, you need to catkinize all dependencies.
catkin_pip_requirements(${PIP_PROJECT_DIR}/requirements.txt --ignore-installed)
# Here we ignore already installed packages, to avoid conflicts with system installed packages (pygments for example)
# However this also means that existing packages in the workspace will not be used to satisfy requirements,
# and will be reinstalled everytime...

# This replace catkin_python_setup()
# For devel, this will install all your unsatisfied pip dependencies.
# Upon install, this will bark if some dependencies are not already satisfied (by ROS).
catkin_pip_target(mypippkg ${PIP_PROJECT_DIR})

catkin_package()

# CAREFUL : all projects for test here will share the same workspace. pip might have conflicts...

## Unit tests
if (CATKIN_ENABLE_TESTING)
    catkin_add_nosetests(${PIP_PROJECT_DIR}/tests DEPENDENCIES mypippkg)
    catkin_add_pytests(${PIP_PROJECT_DIR}/tests DEPENDENCIES mypippkg)
endif()

=== test/pypackage/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(python_boilerplate)

# This is a full project CMakeLists (in case we call it independently for tests or so)
set (PIP_PROJECT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/python_boilerplate)

# NEEDED ONLY FOR TESTING INDEPENDENTLY : Setting up catkin-pip from source via symlink
# add_subdirectory(catkin_pip)

find_package(catkin REQUIRED COMPONENTS catkin_pip)

# For development, we need to install the pip dependencies in the workspace being created
# Upon install, this will not do anything. All requirements should be satisfied by ROS dependencies system.
# => pip dependencies will work from source only
# => to release a pip dependency in a ROS system, you need to catkinize all dependencies.
catkin_pip_requirements(${PIP_PROJECT_DIR}/requirements_dev.txt --ignore-installed)
# Here we ignore already installed packages, to avoid conflicts with system installed packages (pygments for example)
# However this also means that existing packages in the workspace will not be used to satisfy requirements,
# and will be reinstalled everytime...

# This replace catkin_python_setup()
# For devel, this will install all your unsatisfied pip dependencies.
# Upon install, this will bark if some dependencies are not already satisfied (by ROS).
catkin_pip_target(python_boilerplate ${PIP_PROJECT_DIR})

catkin_package()

# CAREFUL : all projects for test here will share the same workspace. pip might have conflicts...

## Unit tests
if (CATKIN_ENABLE_TESTING)
    catkin_add_nosetests(${PIP_PROJECT_DIR}/tests DEPENDENCIES python_boilerplate)
    catkin_add_pytests(${PIP_PROJECT_DIR}/tests DEPENDENCIES python_boilerplate)
endif()

=== debian/changelog ===
ros-lunar-catkin-pip (0.2.3-0xenial) xenial; urgency=high

  * Merge pull request #147 <https://github.com/asmodehn/catkin_pip/issues/147> from pyros-dev/lunar
    adding lunar
  * adding --ignore-src when calling rosdep on tests,
    to not attempt to download an old (or missing) version of catkin_pip.
  * adding lunar
  * Merge pull request #144 <https://github.com/asmodehn/catkin_pip/issues/144> from pyros-dev/fix_destinations
    fixing catkin_destination not being called
  * tests are now using the new catkin_pip_target and calling catkin_package directly.
  * adding catkin_pip_target to API, to allow the user to call catkin_package how he wants.
  * splitting catkin_pip_package in function and macro to expose the catkin_destinations variables set in the scope.
  * adding install rules to verify catkin variables.
  * Merge pull request #128 <https://github.com/asmodehn/catkin_pip/issues/128> from pyros-dev/pyup-update-pytest-3.0.6-to-3.1.3
    Update pytest to 3.1.3
  * Update pytest from 3.0.6 to 3.1.3
  * Contributors: AlexV, pyup-bot

 -- AlexV <asmodehn@gmail.com>  Thu, 10 Aug 2017 15:00:00 -0000

ros-lunar-catkin-pip (0.2.2-0xenial) xenial; urgency=high

  * Merge pull request #123 <https://github.com/asmodehn/catkin_pip/issues/123> from yotabits/devel
    Added option NOSE_OPT to catkin_add_nosetests func
  * Added option NOSE_OPT to catkin_add_nosetests func
    In order to use some specific option for nosetests we now have a NOSE_OPT
    parameter that allow to use some customs options for launching nosetests
    The same has been done for pytests with the param PYTEST_OPT
  * Contributors: AlexV, Thomas

 -- AlexV <asmodehn@gmail.com>  Mon, 29 May 2017 15:00:00 -0000

ros-lunar-catkin-pip (0.2.1-0xenial) xenial; urgency=high

  * Merge pull request #115 <https://github.com/asmodehn/catkin_pip/issues/115> from asmodehn/distutils
    Implementing distutils support
  * refining tests on install flow, to confirm which test framework is used.
    upgrading catkin package format to advised format 2.
  * fixes to support distutils as well as setuptools.
  * adding setuptools_setup test project and tests to validate package structure after installation.
  * adding test to make sure "make install" does not trigger errors.
  * adding a basic package to test distutils based setup.py
  * Contributors: AlexV, yotabits

 -- AlexV <asmodehn@gmail.com>  Wed, 10 May 2017 15:00:00 -0000

ros-lunar-catkin-pip (0.2.0-0xenial) xenial; urgency=high

  * removing dependency on daemontools (not available on fedora)
  * setlock -> flock
  * Merge pull request #95 <https://github.com/asmodehn/catkin_pip/issues/95> from k-okada/install_data
    data should not install right under the CMAKE_INSTALL_PREFIX
  * fixing syntax for ros distro autodetection when building this package.
  * Merge pull request #97 <https://github.com/asmodehn/catkin_pip/issues/97> from asmodehn/gopher-devel
    Preparing next release 0.2
  * install data
  * Contributors: AlexV, Kei Okada, alexv
  * Merge branch 'devel' into gopher-devel
  * now using catkin_pip_runcmd to retrieve cookiecutter package samples.
  * removing install envhook. seems to break things.
    we dont want the install envhook to be created for catkin_pip since the target build env does not exist.
  * Merge pull request #61 <https://github.com/asmodehn/catkin_pip/issues/61> from asmodehn/refactor_envs
    Refactor envs
  * adding docs to make decision clear regarding catkin / pyros_setup behavior.
  * fixing up install devel command since we do not pass editable pkg path into pythonpath anymore.
  * Merge branch 'gopher-devel' into refactor_envs
  * Merge pull request #76 <https://github.com/asmodehn/catkin_pip/issues/76> from asmodehn/easyinstall_fix
    Easyinstall fix
  * commenting install tests... we dont have any.
  * always adding the catkin_pip_env path to pythonpath to be able to find basic tools from the first time around.
  * envhooks now not adding to pythonpath from pth files. too confusing.
    envhooks now not adding non existent paths to pythonpath. maybe good idea to match site module behavior.
    fixing tests.
  * improved tests. added test for check with pyros_setup and interractive debugging
  * fixed broken tests. now needs pyros-setup to get .pth paths before workspaces.
    cosmetics.
  * improved tests and fix all.
    added actual test for pytest to pipproject.
  * cleaning up command args when running pip install --editable to clean python path and workaround pip bug...
  * replacing CI_ROS_DISTRO var by ROS_DISTRO, to have it set for calls to rosdep.
  * more exhaustive test for sys_path
  * commenting echoes from script since it cannot echo without breaking things anyway.
  * reviewing shell script to make them a tiny more robust...
  * removed useless bash envhook, fixed easy-install parse to include last line even if no empty line at end of file.
  * Merge pull request #77 <https://github.com/asmodehn/catkin_pip/issues/77> from asmodehn/pyup-update-pytest-3.0.5-to-3.0.6
    Update pytest to 3.0.6
  * Merge pull request #86 <https://github.com/asmodehn/catkin_pip/issues/86> from asmodehn/pyup-update-cookiecutter-1.5.0-to-1.5.1
    Update cookiecutter to 1.5.1
  * Update cookiecutter from 1.5.0 to 1.5.1
  * moved rosdep install out of catkin_pip, only used for tests.
    temporarily skipping broken test because of pip behavior...
  * improved concurrency handling for pip by using setlock from daemontools.
    improved status message output.
  * adding libssl-dev as dependency forpypackage
  * adding catkin_pip function to call rosdep install. attempting fix for pypackage tests.
  * adding libffi-dev as build_depend for python_boilerplate
  * API changed ! redesigned workflow by doing "pip install -e package" during make stage instead of configure. All tests passing.
  * Update pytest from 3.0.5 to 3.0.6
  * reverted to pip 8.1.2
    changes added in prevision of switching to pip 9.X when --ignore-installed working...


=== debian/control ===
Source: ros-lunar-catkin-pip
Section: misc
Priority: extra
Maintainer: AlexV <asmodehn@gmail.com>
Build-Depends: debhelper (>= 9.0.0), git-core (>= 1.9.1), python-dev (>= 2.7.5), python-pip (>= 1.5.4), ros-lunar-catkin
Homepage: http://github.com/asmodehn/catkin_pip
Standards-Version: 3.9.2

Package: ros-lunar-catkin-pip
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python-dev (>= 2.7.5), python-pip (>= 1.5.4)
Description: Catkin macros to allow using pure python packages in usual catkin workspaces with normal python workflow.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-catkin-pip//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
